<script setup>
import { defineProps, defineEmits } from 'vue';

const props = defineProps({
  cta: {
    type: Object,
    required: false,
    default: null,
  },
  tabs: {
    type: Array,
    required: true,
  },
  selectedTab: {
    type: Number,
    required: true,
  },
});

const emit = defineEmits(['change']);

const handleTabClick = (index) => {
  emit('change', index);
};

const handleKeyDown = (event) => {
  if (event.key === 'ArrowRight') {
    const nextIndex = (props.selectedTab + 1) % props.tabs.length;
    emit('change', nextIndex);
  } else if (event.key === 'ArrowLeft') {
    const prevIndex = (props.selectedTab - 1 + props.tabs.length) % props.tabs.length;
    emit('change', prevIndex);
  }
};
</script>

<template>
  <div class="common-tabs" role="tablist">
    <div class="tabs-container">
      <button
        v-for="(tab, index) in tabs"
        :key="tab.tabId ? tab.tabId : tab"
        :class="{ active: index === selectedTab }"
        role="tab"
        :aria-selected="index === selectedTab ? 'true' : 'false'"
        :tabindex="index === selectedTab ? '0' : '-1'"
        :aria-controls="'tabpanel-' + index"
        @click="handleTabClick(index)"
        @keydown="handleKeyDown($event)"
      >
        <SlpTypography variant="body2-bold">
          {{ tab.tabButtonText ? tab.tabButtonText : tab }}
        </SlpTypography>
      </button>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.tabs-container {
  display: flex;
  justify-content: flex-start;
  overflow: auto;
}
.common-tabs {
  display: flex;
  justify-content: space-between;
  align-items: center;
  width: 100%;
  position: relative;
  &::-webkit-scrollbar {
    display: none;
  }
  margin: $spacing-48 0;
  @media (max-width: $breakpoint-md) {
    justify-content: flex-start;
  }
  button {
    transition: all 0.2s;
    cursor: pointer;
    width: auto;
    white-space: nowrap;
    padding: 0 $spacing-24 $spacing-16 $spacing-24;
    text-align: center;
    border: none;
    border-bottom: 4px solid transparent;
    position: relative;
    transition: color 0.2s;
    outline: none;
  }
  .active {
    color: $color-text-link-100;
    border-bottom: 4px solid #7759c2;
  }
  &:before {
    content: '';
    height: 2px;
    width: 100%;
    background: $color-surface-900;
    position: absolute;
    bottom: 2px;
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }
}
</style>
